/* ----------------------- : 					*/
/*   Original Author       : Unknown (got skeleton/idea in 94 	*/
/*                           from other package and made a 	*/
/*                           program out of it)			*/
/*   Purpose		   : deletes a directory tree.		*/
/*   Usage                 : deltree root                 	*/


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <descrip.h>
#include <ssdef.h>
#include <string.h>

#ifdef __GNUC__
#define cli$present   CLI$PRESENT
#define cli$dcl_parse CLI$DCL_PARSE
#define cli$get_value CLI$GET_VALUE
#else
#include <libclidef.h>
#include <stat.h>
#endif

#include <climsgdef.h>
#include <clidef.h>
#include <time.h>
#include <lib$routines.h>
#include <str$routines.h>
#include <lnmdef.h>



#ifdef __ALPHA
#include <cli$routines.h>
#endif

#if defined(__DECC) || defined(__GNUC__)
#   include <unixlib.h>
#   include <unistd.h>
#   include <unixio.h>
#else
extern int      shell$to_vms()						;
#endif

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef NULL_C
#define NULL_C  '\0'
#endif

#define DIM	 132
#define MAXDEPTH 9
#define VERSION  "V01-205"


#include "deltree_msg.h"


GLOBALDEF(int,dolog,FALSE)						;
GLOBALDEF(int,dodebug,FALSE)						;
GLOBALDEF(int,doconf,TRUE)						;
GLOBALDEF(int,alldir,FALSE)						;
GLOBALDEF(int,depth,0)							;
GLOBALDEF(int,rdepth,0)						        ;
GLOBALDEF(int,count,0)							;


unsigned int	total							;
char		filin[DIM]						;
clock_t 	init_time						;
char		*save_top						;
char		*save_tree						;
char		*tsave_tree						;
int		rtree  = FALSE						;
int		topdir = TRUE						;
int		deepdir= TRUE						;
int		level  = 0						;
int		dochdir()						;


int main(int argc, char *argv[])
{
int	rm_tree()							;
int	flush_file()							;
void	cpu_time()							;
void    get_args(void)							;
int	status								;
int	new_argc=0,i							;
char	**new_argv							;
char	*ptr								;
char    *original							;
char	*top								;
char	*strip()							;


    hack$establish(lib$sig_to_ret)					;
    get_args()								;
    hack$revert();

    /* Grab argument list						*/
    for(ptr = filin; (ptr = strchr(ptr,' ')) != NULL; ptr++, new_argc++);

    if ((new_argv = (char **) calloc (new_argc+1, sizeof(char *))) == NULL)
       	return(SS$_INSFMEM)						;

    for (ptr = filin, i = 0; i <= new_argc; i++) {
        new_argv[i] = ptr						;
        if ((ptr = strchr (ptr, ' ')) != NULL)
            *ptr++ = '\0'						;
    }


    /* Scan now	for files and Unix arguments				*/
    /* Backward compatibility issue					*/
    for(i=0 ; i <= new_argc ; i++){
	if(strcmp(new_argv[i],"-NOCONFIRM")==0 ||
	   strcmp(new_argv[i],"-NOC")==0){
		doconf = FALSE						;
	} else {
		/* Only one file so far					*/
		strcpy(filin,new_argv[i])				;
	}
    }
    free(new_argv)							;

    /* Init timer							*/
    cpu_time(0)							        ;

    /*  save the current default    					*/
    original = (char *) getcwd('\0',BUFSIZ)				;

#ifdef DEBUG
    if(dodebug)printf("deltree :: recording %s\n",original)		;
#endif

    /* Directory expected without "."					*/
    /* Could also extract device name and use an extra chdir() here	*/
    top	= strchr(filin,'.')						;
    if(top)	*top = '\0'						;

    /* Save this for later processing					*/
    save_tree = (char *) malloc(strlen(filin)*sizeof(char))		;
    tsave_tree= save_tree						;
    if(save_tree == NULL) return(SS$_INSFMEM)				;
    strcpy(save_tree,filin)						;


    /*  if a valid root             					*/
    if (chdir(filin) == 0) {
	/*  save the root spec          				*/
#ifdef DEBUG
	if(dodebug)printf("deltree :: chdir() in %s was successful\n",filin);
#endif
        top = (char *) getcwd('\0',BUFSIZ,0)				;

	/* Save top for later file-shortening display			*/
	save_top = (char *) malloc(strlen(top)*sizeof(char))		;
	if(save_top == NULL) return(SS$_INSFMEM)			;
	strcpy(save_top,top)						;

	/* Calculate initial depth					*/
	for(ptr = save_top ; ptr ;){
		if((ptr = strchr(ptr,'/')) != NULL)	depth++, ptr++	;
#if DEBUG
		if(dodebug)printf("%d %s\n",depth,ptr)			;
#endif
	}


	/* Fix top with .dir						*/
        strncat(top,".dir.",BUFSIZ)					;

	/*  go back home                				*/
	chdir(original)						        ;
	free(original)							;

	/*  and let the fun begin       				*/
	if(dodebug)hack$signal(DELTREE__BEGIN_msg_hack)		        ;
	status = SS$_NORMAL						;
	if(rm_tree(filin)){
		/*  finally, remove the root    			*/
		if(topdir){
			status = flush_file(top)			;
		} else {
			hack$signal(DELTREE__PRSRVD_msg_hack,1,strip(filin));
		}
	}
	if(count != 0)status = SS$_NORMAL				;
        free(top)							;
	free(save_top)							;
	if(dolog)cpu_time(1)						;
    } else {
	status = DELTREE__NOTFND					;
    }
    if(dodebug)hack$signal(DELTREE__END_msg_hack)			;
    free(save_tree)							;
    return status							;
}

/* -------------------------------------------------------------------- */
/*  remove tree - call shell$to_vms to remove files  			*/
/* -------------------------------------------------------------------- */
int rm_tree(char *s)
{
int	action(char *)							;
char	*strip()							;

    if(doconf && (rdepth==1 || alldir)){
	char	ans							;

	printf("deltree :: Delete %s%s ? "				,
		(strcmp(tsave_tree,s)==0?"./":tsave_tree),strip(s))	;
	scanf("%s",&ans)						;
	ans = tolower(ans)						;
	if (ans != 'y'){
		count++						        ;
		return FALSE						;
	}
    }

    /*  move to target dir      					*/
    if(dochdir(1,s)==0){

     /* blow everything (?) away.					*/
     /* Actually the .*;* remains so we have to treat them separatly	*/
     if(dodebug)hack$signal(DELTREE__BFLUSH_msg_hack,1,s)		;

     shell$from_vms(".*;*",action,1)					;
     shell$from_vms("*.*;*",action,1)					;

     if(dodebug)hack$signal(DELTREE__EFLUSH_msg_hack,3,s,doconf,dodebug);

     /*  move back one							*/
     dochdir(-1,"[-]")							;
     return TRUE							;
    } else {
     return FALSE							;
    }
}


/* -------------------------------------------------------------------- */
/*  this routine is reponsible for file deletion			*/
/* -------------------------------------------------------------------- */
int action(char *name)
{
char	*ps								;
int	sts,flush_file()						;


    /*  is this a directory?  						*/
    if ((ps=strstr(name,".DIR.")) != '\0'){
        *ps = '\0'							;
	sts = rm_tree(name)						;

        *ps = '.'							;
	if(sts==1) sts = flush_file(name)				;
    } else {
	/*  it's a file, so						*/
	sts = flush_file(name)						;
    }
    return 1								;
}


int	flush_file(char *name)
{
int	stat,sts							;
char	*strip()							;

	stat	= SS$_NORMAL						;

	sts 	= chmod(name,0777)					;
	if(sts != 0){
		if(dolog)hack$signal(DELTREE__NOPROT_msg_hack,2,tsave_tree,strip(name));
		stat = DELTREE__PRV					;
	}

	sts	= delete(name)						;
	if(sts != 0 ){
		if(dolog)hack$signal(DELTREE__NODELE_msg_hack,2,tsave_tree,strip(name));
		if(stat == SS$_NORMAL)stat = DELTREE__TREENOTDEL	;
	} else {
		total++						        ;
	}
	return stat							;
}



/* --------------------------------------------------------------------	*/
/* String manipulation routines						*/
/* --------------------------------------------------------------------	*/
char	*strip(char *st)
{
char	*base,*name							;

	base = save_top; name = st					;
	for(; *name && *name == *base; name++,base++)			;
	return name							;
}


int dochdir(int i,char *st)
{
 rdepth += i								;
 depth  += i								;

 /* 10 = 8 + 2 ; 2 comes from "/" at beginning of disk name, "/" between
    disk name and first directory from 000000				*/
#ifdef DEBUG
 if(dodebug)printf("chdir() if %d%%%d && %d (%d)\n",depth,MAXDEPTH,i,doconf);
#endif
/*  if( (depth%MAXDEPTH) == 0 && i > 0 && deepdir){                     */
 if( (depth%MAXDEPTH) == 0 && i > 0 ){
	/* Solve it with a recursive loop				*/
#ifdef DEBUG
        if(dodebug)printf("level=%d depth encountered. %d (%d)\n",level,dodebug,doconf);
#endif
	if(level == 0){
		$DESCRIPTOR(logical,"")				        ;
		$DESCRIPTOR(value,"")					;
		$DESCRIPTOR(parent,"")					;
		$DESCRIPTOR(flag_desc,"")				;

		char	*expectedcd					;
		char	*ptr,*disk					;
		char	*tmp1,*tmp2					;
		char	*env						;
		char	direct[512]					;
		int	len						;
		unsigned long trans					;

		direct[0] = '\0'					;

		if(dolog)hack$signal(DELTREE__DEEPDIR_msg_hack,1,strip(st));
#ifdef DEBUG
	        if(dodebug)printf("Directory String %s\n",st)		;
#endif

		/* Copy directory, skip first slash, chage to dots	*/
		ptr	 = (char *) malloc(sizeof(char *)*(strlen(st))) ;
		strcpy(ptr,st+1)					;

		for(disk = ptr ; (disk = strchr(disk,'/')) != NULL ; disk++)
				*disk = '.'				;


		/* Get disk and directory name				*/
		disk	= (char *) malloc(sizeof(char *)*(strlen(ptr))) ;
		strcpy(disk,ptr)					;
		tmp1	= strchr(disk,'.')				;
		tmp2	= strrchr(disk,'.')				;
		if(tmp1 == NULL || tmp2 == NULL){
			hack$signal(DELTREE__BUGCHK_msg_hack)		;
			abort()					        ;
		}
		*tmp1	= '\0'						;
		*tmp2	= '\0'						;
		tmp2++							;

		if( (env = getenv(disk)) == NULL_C){
			/* was not a logical				*/
			if(dodebug)hack$signal(DELTREE__GETENV_msg_hack,1,"(null)");
			len	= strlen(disk)				;
			strcpy(direct,disk)				;
			direct[len++] = ':'				;
			direct[len++] = '['				;
			direct[len]   = '\0'				;
			strncat(direct,tmp1+1,BUFSIZ)			;
			len	+= strlen(tmp1+1)			;
#ifdef DEBUG
			if(dodebug)printf("deltree :: Now have %s\n",direct);
#endif
		} else {
			/* Was a logical				*/
			strcpy(direct,env)				;
			if(dodebug)hack$signal(DELTREE__GETENV_msg_hack,1,direct);
			direct[strlen(direct)-1] = '\0'		        ;
			len	= strlen(direct)+strlen(tmp1+1)+1	;
			strncat(direct,tmp1+1,BUFSIZ)			;
		}
		/* strcat() did not work here				*/
		direct[len++]	= '.'					;
		direct[len++]	= ']'					;
		direct[len]	= '\0'					;


#ifdef DEBUG
		if(dodebug){
			printf("Ptr  is %s\n",ptr)			;
			printf("Disk is %s\n",disk)			;
			printf("Dir  is %s\n",tmp2)			;
			printf("Dirf is %s\n",direct)			;
			printf("Len  is %d\n",len)			;
		}
#endif


		/* Define the logical					*/
		/* Sets logical, change directory, recursively delete
		   files and come back					*/
		logical.dsc$a_pointer	= "DELTREE_NEWTOP"		;
		logical.dsc$w_length 	= strlen(logical.dsc$a_pointer) ;
		strcpy(value.dsc$a_pointer,direct)			;
		value.dsc$w_length	= strlen(value.dsc$a_pointer)	;
		parent.dsc$a_pointer	= "LNM$PROCESS_TABLE"		;
		parent.dsc$w_length	= strlen(parent.dsc$a_pointer)	;
		trans	= LNM$M_CONCEALED | LNM$M_TERMINAL		;
		lib$set_logical(&logical, &value, &parent, &trans)	;


		/* Just in case ...					*/
		expectedcd = (char *) malloc(sizeof(char *)*(strlen(st)+1));
		strcpy(expectedcd,st)					;
#ifdef DEBUG
		if(dodebug)printf("expectedcd is %s\n",expectedcd)	;
#endif

		tsave_tree = (char *) malloc(sizeof(char *)*strlen("deltree_newtop/"));
		strcpy(tsave_tree,"deltree_newtop/")			;
		chdir("DELTREE_NEWTOP:[000000]")			;
		level++						        ;
		if(! rm_tree(tmp2) && dolog){
			if(dolog)hack$signal(DELTREE__DEEPFAIL_msg_hack);
		} else {
			if(dodebug)hack$signal(DELTREE__DEEPOK_msg_hack);
		}
		level--						        ;
		free(tsave_tree)					;
		tsave_tree	= save_tree				;

		/* Note that we need to pretend that we changed directory */
		/* so old-root is the directory we received		*/
		if(chdir(expectedcd) != 0){
			hack$signal(DELTREE__CHDIR_msg_hack)		;
			abort()					        ;
		}
		free(expectedcd)					;
		free(ptr)						;
		free(disk)						;
		return 0						;
	} else {
		if(dolog)hack$signal(DELTREE__TOODEEP_msg_hack,1,st)	;
		return -1						;
	}
 } else {
	/* Try to do that but it might fail				*/
	return chdir(st)						;
 }
}




/* --------------------------------------------------------------------	*/
/* Routines to get the arguments from the command line			*/
/* --------------------------------------------------------------------	*/

void get_args(void)
{
unsigned int	CLI_PRESENT()						;
unsigned int	status							;

void			exit_lhelp()					;

#if defined(__DECC) || defined(__GNUC__)
extern char	*DELTREE						;
#else
globalref	DELTREE						        ;
#endif

struct dsc$descriptor line_str_d={0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0}	;
$DESCRIPTOR(command,"DELTREE ")					        ;
$DESCRIPTOR(filin_d,"INFILE")						;

	lib$get_foreign(&line_str_d)					;
	str$concat(&line_str_d,&command,&line_str_d)			;
	status = cli$dcl_parse(&line_str_d,&DELTREE)			;
	if (!(status & 1))exit(status)					;

	if( CLI_PRESENT("HELP") == CLI$_PRESENT)	exit_lhelp(SS$_NORMAL);
	if( CLI_PRESENT("TREE") == CLI$_PRESENT	)	rtree	= TRUE	;

	status = CLI_PRESENT("LOG")					;
	if( status == CLI$_PRESENT)	dolog	= TRUE			;
	if( status == CLI$_NEGATED)	dolog	= FALSE		        ;

#ifdef BACKWARD_COMPAT
	/* Old option NO LONGER supported because not suitable for 	*/
	/* DELETE verb modification					*/
	status = CLI_PRESENT("SUBDIR")					;
	if( status == CLI$_PRESENT)	alldir	= TRUE			;
	if( status == CLI$_NEGATED)	alldir	= FALSE		        ;
#endif

	/* This keyword is the new supported one. DELETE command has	*/
	/* it and therefore /ALL will be possible without major CLD	*/
	/* Modifications.						*/
	status = CLI_PRESENT("ALL")					;
	if( status == CLI$_PRESENT)	alldir	= TRUE			;
	if( status == CLI$_NEGATED)	alldir	= FALSE		        ;

	status = CLI_PRESENT("TOP")					;
	if( status == CLI$_PRESENT)	topdir	= TRUE			;
	if( status == CLI$_NEGATED)	topdir	= FALSE		        ;

/* 	status = CLI_PRESENT("DEEP")					; */
/* 	if( status == CLI$_PRESENT)	deepdir	= TRUE			; */
/* 	if( status == CLI$_NEGATED)	deepdir	= FALSE		        ; */

	status = CLI_PRESENT("DEBUG")					;
	if( status == CLI$_PRESENT)	dodebug	= TRUE			;
	if( status == CLI$_NEGATED)	dodebug	= FALSE		        ;

	status = CLI_PRESENT("CONFIRM")				        ;
	if( status == CLI$_PRESENT)	doconf	= TRUE			;
	if( status == CLI$_NEGATED)	doconf	= FALSE		        ;

	if( !( cli$get_value(&filin_d,&line_str_d) & 1) ){
	 exit_lhelp(DELTREE__NODIR)					;
	} else {
	 strncpy(filin,line_str_d.dsc$a_pointer,line_str_d.dsc$w_length);
	 filin[line_str_d.dsc$w_length] = '\0'				;
	}
}

unsigned int CLI_PRESENT(char *item)
{
struct dsc$descriptor item_d={0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0}		;

	item_d.dsc$w_length = strlen(item)				;
	item_d.dsc$a_pointer= (void *) item				;
	item_d.dsc$b_class  = DSC$K_CLASS_S				;
	item_d.dsc$b_dtype  = DSC$K_DTYPE_T				;
	return cli$present(&item_d)					;
}


/* -------------------------------------------------------------------	*/
/*   Original Author       : JLAURET					*/
/*   Date                  : 20-OCT-1995 				*/
/* ----------------------- :                                            */
/*   Purpose of Revision   : Got rid of pointer on int and void now	*/
/* -------------------------------------------------------------------	*/
#ifdef VMS
# define CLK_SCALE CLK_TCK
#else
# define CLK_SCALE CLOCKS_PER_SEC
#endif


/* Pointer on integer so we can use it in FORtran 			*/
void cpu_time(int what)
{
clock_t	lc								;

	lc = clock()							;
	if (what == 0) {
		if(lc < 0)exit(DELTREE__CLKINIT)			;
		init_time = lc						;
	} else {
		char	st[DIM]					        ;
		lc = lc - init_time					;
		sprintf(st,"%.1f",(float) lc/CLK_SCALE)		        ;
		hack$signal(DELTREE__STAT_msg_hack,3,total,tsave_tree,st);
	}
}




/* -------------------------------------------------------------------	*/
/* Don't panic. Formated with TEXT2C					*/
/* -------------------------------------------------------------------	*/
void	exit_lhelp(int sts)
{
printf("\nDELTREE version %s Copyright (C) Jrme LAURET\n",VERSION)	;
#include "deltree_help.c"
exit(sts)								;
}



/* ----------------------- : 						*/
/*   Date of Revision      : 1998 					*/
/*   Change Author         : JLAURET					*/
/*   Purpose of Revision   : Added the .*;* files 			*/
/*                         : Remains the deep tree problem		*/
/* ----------------------- : 						*/
/*   Date of Revision      : 20-JAN-1999 				*/
/*   Change Author         : JLAURET					*/
/*   Purpose of Revision   : Made it GCC compatible			*/
/*                         : Now tested with DECC & GCC (Alpha), VAXC	*/
/* ----------------------- : 						*/
/*   Date of Revision      : 29-JAN-1999 				*/
/*   Change Author         : JLAURET					*/
/*   Purpose of Revision   : Added Cli interface and options		*/
/*                         : 						*/
/* ----------------------- :                                            */
/*   Date of Revision      :  9-APR-1999                                */
/*   Change Author         : JLAURET                                    */
/*   Purpose of Revision   : Added deep tree mechanism.                 */
/*                         :                                            */
/* ----------------------- :                                            */
/*   Date of Revision      : 28-JUN-1999                                */
/*   Change Author         : JLAURET                                    */
/*   Purpose of Revision   : GCC small cleanup.				*/
/*                         :                                            */
